#include <windows.h>
#include <stdio.h>


char* packArgument(int argc, char** argv)
{
	int length = 0, offset =0;
	int i;
	char* ptr = NULL;
	for (i=0; i< argc; i++)
	{
		length += strlen(argv[i]) + 1;
	}
	if ((ptr = (char*)malloc(length))!= NULL)
	{
		for (i = 0; i <argc; i++)
		{
			length = strlen(argv[i]);
			strcpy(ptr + offset, argv[i]);
			offset+= length;
			ptr[offset]=' ';
			offset++;
		}
		ptr[offset-1]='\0';
	}
	return ptr;
}
			


int main(int argc, char** argv)
{
	PROCESS_INFORMATION pi;
	STARTUPINFO si;
	char* ptr;
	unsigned long nExit;

	ZeroMemory(&pi, sizeof(PROCESS_INFORMATION));
	ZeroMemory(&si, sizeof(STARTUPINFO));

	si.cb = sizeof(STARTUPINFO);

	if ((ptr = packArgument(argc -1, argv + 1))!= NULL)
	{
		printf("command=%s, argument=%s\n", argv[1], ptr);
		if (CreateProcess(argv[1], ptr, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi))
		{
			WaitForSingleObject(pi.hProcess, INFINITE);
			GetExitCodeProcess(pi.hProcess, &nExit);
			CloseHandle(pi.hProcess);
			CloseHandle(pi.hThread);
			printf("command[%s] exits with %d\n", argv[1], nExit);
		}
		free(ptr);
	}

	return 0;
}
